#include "lfr_state_machine.h"

/* void State::Idle::toggle(LFR_StateMachine* stateMachine)
{
    stateMachine->setState()
} */

void State::Idle::enter(LFR_StateMachine* stateMachine)
{

}

void State::Idle::exit(LFR_StateMachine* stateMachine)
{
    
}

LFR_State& State::Idle::getInstance()
{
    static State::Idle singleton;
    return singleton;
}

void State::Autonomous::enter(LFR_StateMachine* stateMachine)
{

}

void State::Autonomous::exit(LFR_StateMachine* stateMachine)
{
    stateMachine->setState(State::Idle::getInstance());
}

LFR_State& State::Autonomous::getInstance()
{
    static State::Autonomous singleton;
    return singleton;
}

void State::Manual::enter(LFR_StateMachine* stateMachine)
{

}

void State::Manual::exit(LFR_StateMachine* stateMachine)
{
    stateMachine->setState(State::Idle::getInstance());
}

LFR_State& State::Manual::getInstance()
{
    static State::Manual singleton;
    return singleton;
}